Package weka.classifiers.lazy

# Class LBR

java.lang.Object
weka.classifiers.Classifier
weka.classifiers.lazy.LBR

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `CapabilitiesHandler`, `OptionHandler`, `RevisionHandler`, `TechnicalInformationHandler`

public class LBR extends Classifier implements TechnicalInformationHandler
Lazy Bayesian Rules Classifier. The naive Bayesian classifier provides a simple and effective approach to classifier learning, but its attribute independence assumption is often violated in the real world. Lazy Bayesian Rules selectively relaxes the independence assumption, achieving lower error rates over a range of learning tasks. LBR defers processing to classification time, making it a highly efficient and accurate classification algorithm when small numbers of objects are to be classified.
For more information, see:
Zijian Zheng, G. Webb (2000). Lazy Learning of Bayesian Rules. Machine Learning. 4(1):53-84.

BibTeX:

     @article{Zheng2000,
        author = {Zijian Zheng and G. Webb},
        journal = {Machine Learning},
        number = {1},
        pages = {53-84},
        title = {Lazy Learning of Bayesian Rules},
        volume = {4},
        year = {2000}
     }

Valid options are:

     -D
      If set, classifier is run in debug mode and
      may output additional info to the console

Version:
  $Revision: 5525 $
Author:
  Zhihai Wang (zhw@deakin.edu.au) : July 2001 implemented the algorithm, Jason Wells (wells@deakin.edu.au) : November 2001 added instance referencing via indexes
See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`LBR.Indexes`
Class for handling instances and the associated attributes.

## Constructor Summary

Constructors
Constructor
Description
`LBR()`

## Method Summary

Modifier and Type
Method
Description
`double`
`binomP(double r, double n, double p)`
Significance test binomp:
`void`
`buildClassifier(Instances instances)`
For lazy learning, building classifier is only to prepare their inputs until classification time.
`double[]`
`distributionForInstance(Instance testInstance)`
Calculates the class membership probabilities for the given test instance.
`Capabilities`
`getCapabilities()`
Returns default capabilities of the classifier.
`String`
`getRevision()`
Returns the revision string.
`TechnicalInformation`
`getTechnicalInformation()`
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.
`String`
`globalInfo()`
`int`
`leaveOneOut(LBR.Indexes instanceIndex, int[][][] counts, int[] priors, boolean[] errorFlags)`
Leave-one-out strategy.
`double[]`
`localDistributionForInstance(Instance instance, LBR.Indexes instanceIndex)`
Calculates the class membership probabilities.
`void`
`localNaiveBayes(LBR.Indexes instanceIndex)`
Class for building and using a simple Naive Bayes classifier.
`static void`
`main(String[] argv)`
Main method for testing this class.
`String`
`toString()`
Returns a description of the classifier.

### Methods inherited from class weka.classifiers.Classifier

`classifyInstance, debugTipText, forName, getDebug, getOptions, listOptions, makeCopies, makeCopy, setDebug, setOptions`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### LBR

public LBR()

## Method Details

### globalInfo

public String globalInfo()

Returns:
  a description of the classifier suitable for displaying in the explorer/experimenter gui

### getTechnicalInformation

public TechnicalInformation getTechnicalInformation()
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.

Specified by:
  `getTechnicalInformation` in interface `TechnicalInformationHandler`
Returns:
  the technical information about this class

### getCapabilities

public Capabilities getCapabilities()
Returns default capabilities of the classifier.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `Classifier`
Returns:
  the capabilities of this classifier
See Also:
  - `Capabilities`

### buildClassifier

public void buildClassifier(Instances instances) throws Exception
For lazy learning, building classifier is only to prepare their inputs until classification time.

Specified by:
  `buildClassifier` in class `Classifier`
Parameters:
  `instances` - set of instances serving as training data
Throws:
  `Exception` - if the preparation has not been generated.

### distributionForInstance

public double[] distributionForInstance(Instance testInstance) throws Exception
Calculates the class membership probabilities for the given test instance. This is the most important method for Lazy Bayesian Rule algorithm.

Overrides:
  `distributionForInstance` in class `Classifier`
Parameters:
  `testInstance` - the instance to be classified
Returns:
  predicted class probability distribution
Throws:
  `Exception` - if distribution can't be computed

### toString

public String toString()
Returns a description of the classifier.

Overrides:
  `toString` in class `Object`
Returns:
  a description of the classifier as a string.

### leaveOneOut

public int leaveOneOut(LBR.Indexes instanceIndex, int[][][] counts, int[] priors, boolean[] errorFlags) throws Exception
Leave-one-out strategy. For a given sample data set with n instances, using (n - 1) instances by leaving one out and tested on the single remaining case. This is repeated n times in turn. The final "Error" is the sum of the instances to be classified incorrectly.

Parameters:
  `instanceIndex` - set of instances serving as training data.
  `counts` - serving as all the counts of training data.
  `priors` - serving as the number of instances in each class.
  `errorFlags` - for the errors
Returns:
  error flag array about each instance.
Throws:
  `Exception` - if something goes wrong

### localNaiveBayes

public void localNaiveBayes(LBR.Indexes instanceIndex) throws Exception
Class for building and using a simple Naive Bayes classifier. For more information, see

Richard Duda and Peter Hart (1973).Pattern Classification and Scene Analysis. Wiley, New York. This method only get m_Counts and m_Priors.

Parameters:
  `instanceIndex` - set of instances serving as training data
Throws:
  `Exception` - if m_Counts and m_Priors have not been generated successfully

### localDistributionForInstance

public double[] localDistributionForInstance(Instance instance, LBR.Indexes instanceIndex) throws Exception
Calculates the class membership probabilities. for the given test instance.

Parameters:
  `instance` - the instance to be classified
  `instanceIndex` -
Returns:
  predicted class probability distribution
Throws:
  `Exception` - if distribution can't be computed

### binomP

public double binomP(double r, double n, double p) throws Exception
Significance test binomp:

Parameters:
  `r` -
  `n` -
  `p` -
Returns:
  returns the probability of obtaining r or fewer out of n if the probability of an event is p.
Throws:
  `Exception` - if computation fails

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `Classifier`
Returns:
  the revision

### main

public static void main(String[] argv)
Main method for testing this class.

Parameters:
  `argv` - the options